/*

RemindMe

*/

#ifndef __DATE_HPP__
#define __DATE_HPP__

unsigned char DaysInMonth(unsigned char m, unsigned int y);
unsigned char DayOfWeek(unsigned char dom, unsigned char m, unsigned int y);

enum RMNthTagType
{
    NthFirst = 1,
    NthSecond,
    NthThird,
    NthFourth,
    NthFifth,
    NthLast
};

unsigned char NthDayOfMonth(unsigned char nth, unsigned char dow,
    unsigned char m, unsigned int y);

struct RMDateType
{
    RMDateType() {DayOfMonth = 0; DayOfWeek = 0; Month = 0; Year = 0;}
    RMDateType(unsigned int g);
    unsigned int Gregorian();
    unsigned int GregorianMonths();
    void Yesterday();
    void Tomorrow();
    void PlusDays(int d);
    void MinusDays(int d);
    void NextWeek() {PlusDays(7);}
    void NextMonth();
    void LastWeek() {MinusDays(7);}
    void LastMonth();
    int Match(RMDateType dt);
    bool operator ==(RMDateType dt);

    unsigned char DayOfMonth; // 1 ... 31; 0 : unspecified
    unsigned char DayOfWeek; // 1 ... 7 (sun ... sat); 0 : unspecified
    unsigned char Month; // 1 ... 12 (jan ... dec); 0 : unspecified
    unsigned int Year; // 1800 ... 3000; 0 : unspecified
};


RMDateType GetCurrentDate();

#endif // __DATE_HPP__
