/*

RemindMe

*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "remindme.hpp"
#include "date.hpp"

int ChLetter(Ch ch)
{
    return((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z'));
}

int ChNumber(Ch ch)
{
    return(ch >= '0' && ch <= '9');
}

int ChStringEqualIC(Ch * s1, Ch * s2)
{
    return(stricmp((char *) s1, (char *) s2) == 0);
}

RMDateType GetCurrentDate()
{
    RMDateType cdt;
    SYSTEMTIME st;

    GetLocalTime(&st);
    cdt.DayOfMonth = (unsigned char) st.wDay;
    cdt.Month = (unsigned char) st.wMonth;
    cdt.Year = st.wYear;

    return(cdt);
}

static FILE * TryFilename(char * fn, char * fb)
{
    strcpy(fb, getenv("USERPROFILE"));
    strcat(fb, "/");
    strcat(fb, fn);
    return(fopen(fb, "r"));
}

FILE * GetDefaultFilename(char ** fn)
{
    FILE * fp;
    static char fb[MAX_PATH];

    *fn = fb;

    fp = TryFilename("remindme.rme", fb);
    if (fp != 0)
        return(fp);
    fp = TryFilename("remindme/remindme.rme", fb);
    if (fp != 0)
        return(fp);

    fp = TryFilename("My Documents/remindme.rme", fb);
    if (fp != 0)
        return(fp);
    fp = TryFilename("My Documents/RemindMe/remindme.rme", fb);
    if (fp != 0)
        return(fp);

    return(0);
}

Ch * GetPathFromFilename(Ch * fn)
{
    Ch * p;
    DWORD pl;
    LPTSTR fp;

    pl = GetFullPathName((char *) fn, 0, 0, &fp);
    p = new Ch[pl];
    GetFullPathName((char *) fn, pl, (char *) p, &fp);
    *fp = 0;
    return(p);
}

